/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     NUMBER = 259,
     STRING = 260,
     SUBSYSTEM = 261,
     TIMEOUT = 262,
     DEFINE = 263,
     NEW_CONNECTION = 264,
     TYPEDEF = 265,
     RPC2_STRUCT = 266,
     RPC2_ENUM = 267,
     CLIENT = 268,
     SERVER = 269,
     PREFIX = 270,
     IN = 271,
     OUT = 272
   };
#endif
#define IDENTIFIER 258
#define NUMBER 259
#define STRING 260
#define SUBSYSTEM 261
#define TIMEOUT 262
#define DEFINE 263
#define NEW_CONNECTION 264
#define TYPEDEF 265
#define RPC2_STRUCT 266
#define RPC2_ENUM 267
#define CLIENT 268
#define SERVER 269
#define PREFIX 270
#define IN 271
#define OUT 272




/* Copy the first part of user declarations.  */
#line 1 "rp2gen_parser.y"
 /* BLURB gpl

                           Coda File System
                              Release 5

          Copyright (c) 1987-1999 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

                        Additional copyrights

#*/

/*
                         IBM COPYRIGHT NOTICE

                          Copyright (C) 1986
             International Business Machines Corporation
                         All Rights Reserved

This  file  contains  some  code identical to or derived from the 1986
version of the Andrew File System ("AFS"), which is owned by  the  IBM
Corporation.   This  code is provided "AS IS" and IBM does not warrant
that it is free of infringement of  any  intellectual  rights  of  any
third  party.    IBM  disclaims  liability of any kind for any damages
whatsoever resulting directly or indirectly from use of this  software
or  of  any  derivative work.  Carnegie Mellon University has obtained
permission to  modify,  distribute and sublicense this code,  which is
based on Version 2  of  AFS  and  does  not  contain  the features and
enhancements that are part of  Version 3 of  AFS.  Version 3 of AFS is
commercially   available   and  supported  by   Transarc  Corporation,
Pittsburgh, PA.

*/

#include <stdio.h>
#include <stdlib.h>
#include "rp2.h"

extern int yydebug;
extern int HeaderOnlyFlag;

extern char *copy();
extern RPC2_TYPE *rpc2_enum_type(), *rpc2_struct_type();
extern ENTRY *make_entry(), *find();
extern ENUM *make_enum();
extern VAR *make_var();
extern PROC *make_proc(), *check_proc();
extern void enter();
extern char *concat();
extern struct subsystem subsystem;
extern void no_storage(char *);
extern void spit_define(char *, char *);
extern void insert(PROC *proc);

/* Structure for handling IDENTIFIER lists */

#define MAX_IDS	100

struct {
    char	*ids[MAX_IDS];
    int		counter;
} id_list;

static char **make_id_array()
{
    register char **array;
    register int i;

    array = (char **) calloc(id_list.counter+1, sizeof(char *));
    if (array == NIL) no_storage("make_id_array");
    array[id_list.counter] = NIL;
    for (i=0, id_list.counter--; id_list.counter>=0; i++, id_list.counter--)
	array[i] = id_list.ids[id_list.counter];
    return array;
}

#define MAX_ENUMS	100

struct {
    ENUM	*enums[MAX_ENUMS];
    int		counter;
} enum_list;

static ENUM **make_enum_array()
{
    register ENUM **array;
    register int i;

    array = (ENUM **) calloc(enum_list.counter+1, sizeof(ENUM *));
    if (array == NIL) no_storage("make_enum_array");
    array[enum_list.counter] = NIL;
    for (i=0, enum_list.counter--; enum_list.counter>=0; i++, enum_list.counter--)
	array[i] = enum_list.enums[enum_list.counter];
    return array;
}

#define MAX_FORMALS	100

struct {
    VAR		*formals[MAX_FORMALS];
    int		counter;
} formal_list;

static VAR **make_formal_array()
{
    register VAR **array;
    register int i;

    array = (VAR **) calloc(formal_list.counter+1, sizeof(VAR *));
    if (array == NIL) no_storage("make_formal_array");
    array[formal_list.counter] = NIL;
    for (i=0, formal_list.counter--; formal_list.counter>=0; i++, formal_list.counter--)
	array[i] = formal_list.formals[formal_list.counter];
    return array;
}

#define MAX_VARS	100

struct {
    VAR		**vars[MAX_VARS];
    int		counter;
} var_list;

static int length(p)
    char **p;
{
    register int len;

    for (len=0; *p!=NIL; p++) len++;
    return len;
}

static VAR **make_var_array()
{
    register int count, i;
    register VAR **array;

    for (i=0, count=0; i<var_list.counter; i++) count += length((char **)var_list.vars[i]);
    array = (VAR **) calloc(count+1, sizeof(VAR *));
    if (array == NIL) no_storage("make_var_array");
    array[count] = NIL;

    /* Transfer to array */
    for (i=0, var_list.counter--; var_list.counter>=0; var_list.counter--) {
	register VAR **v;
	for (v = var_list.vars[var_list.counter]; *v != NIL; v++)
	    array[i++] = *v;
    }
    return array;
}

static char *createsize(name)
    char *name;
{
    return concat(name, "_size_");
}

static char *createmaxsize(name)
    char *name;
{
    return concat(name, "_max_size_");
}

int next_opnum = 1;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 186 "rp2gen_parser.y"
typedef union YYSTYPE {
    rp2_bool	u_bool;
    MODE	u_mode;
    char	*u_string;
    char	**u_string_array;
    RPC2_TYPE	*u_rpc2_type;
    ENTRY	*u_entry;
    ENUM	*u_enum;
    VAR		*u_var;
    VAR		**u_var_array;
    VAR		***u_var_array_array;
    int         u_int;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 296 "rp2gen_parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 308 "rp2gen_parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   101

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  28
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  36
/* YYNRULES -- Number of rules. */
#define YYNRULES  61
/* YYNRULES -- Number of states. */
#define YYNSTATES  115

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   272

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      19,    20,     2,     2,    23,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    27,    18,
       2,    24,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    25,     2,    26,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    21,     2,    22,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     8,    10,    12,    15,    20,    25,    30,
      32,    35,    37,    39,    41,    43,    49,    51,    54,    56,
      58,    60,    62,    66,    70,    76,    78,    80,    82,    84,
      89,    92,    94,    98,   100,   104,   106,   111,   115,   117,
     121,   125,   127,   130,   132,   141,   144,   146,   151,   154,
     156,   160,   162,   164,   167,   172,   174,   176,   178,   180,
     182,   184
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      29,     0,    -1,    30,    32,    37,    38,    -1,    63,    -1,
      31,    -1,    31,    31,    -1,    14,    15,    62,    18,    -1,
      13,    15,    62,    18,    -1,     6,    34,    33,    18,    -1,
      63,    -1,    35,    36,    -1,    63,    -1,    62,    -1,    61,
      -1,    61,    -1,     7,    19,    61,    20,    18,    -1,    63,
      -1,    38,    39,    -1,    63,    -1,    41,    -1,    40,    -1,
      54,    -1,     8,     3,     4,    -1,     8,     3,    62,    -1,
      10,    42,     3,    52,    18,    -1,    43,    -1,    44,    -1,
      49,    -1,     3,    -1,    11,    21,    45,    22,    -1,    46,
      45,    -1,    46,    -1,    43,    47,    18,    -1,    48,    -1,
       3,    23,    48,    -1,     3,    -1,    12,    21,    50,    22,
      -1,    51,    23,    50,    -1,    51,    -1,     3,    24,     4,
      -1,    25,    61,    26,    -1,    63,    -1,    25,    26,    -1,
      63,    -1,    55,     3,    19,    56,    20,    59,    60,    18,
      -1,     4,    27,    -1,    63,    -1,    57,    53,    23,    56,
      -1,    57,    53,    -1,    63,    -1,    58,    43,     3,    -1,
      16,    -1,    17,    -1,    16,    17,    -1,     7,    19,    61,
      20,    -1,    63,    -1,     9,    -1,    63,    -1,     4,    -1,
       3,    -1,     5,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   226,   226,   229,   230,   231,   234,   240,   248,   253,
     260,   262,   265,   269,   273,   277,   279,   283,   284,   287,
     288,   289,   293,   295,   299,   314,   316,   318,   322,   332,
     336,   344,   351,   364,   368,   376,   383,   387,   395,   402,
     406,   408,   412,   416,   420,   433,   436,   441,   469,   492,
     496,   502,   504,   506,   510,   512,   516,   518,   522,   524,
     528,   536
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "NUMBER", "STRING", 
  "SUBSYSTEM", "TIMEOUT", "DEFINE", "NEW_CONNECTION", "TYPEDEF", 
  "RPC2_STRUCT", "RPC2_ENUM", "CLIENT", "SERVER", "PREFIX", "IN", "OUT", 
  "';'", "'('", "')'", "'{'", "'}'", "','", "'='", "'['", "']'", "':'", 
  "$accept", "file", "prefixes", "prefix", "header_line", 
  "compatability_stuff", "subsystem_name", "id_number", 
  "protocol_version", "default_timeout", "decl_or_proc_list", 
  "decl_or_proc", "define", "typedef", "rpc2_type", "type_name", 
  "rpc2_struct", "field_list", "field", "identifier_list", 
  "identifier_list2", "rpc2_enum", "enum_val_list", "enum_val", 
  "array_spec", "array_spec_var", "procedure_description", 
  "opcode_number", "formal_list", "formal", "usage", "timeout_override", 
  "new_connection", "DefinedNumber", "String", "empty", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,    59,    40,
      41,   123,   125,    44,    61,    91,    93,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    28,    29,    30,    30,    30,    31,    31,    32,    32,
      33,    33,    34,    35,    36,    37,    37,    38,    38,    39,
      39,    39,    40,    40,    41,    42,    42,    42,    43,    44,
      45,    45,    46,    47,    48,    48,    49,    50,    50,    51,
      52,    52,    53,    53,    54,    55,    55,    56,    56,    56,
      57,    58,    58,    58,    59,    59,    60,    60,    61,    61,
      62,    63
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     4,     1,     1,     2,     4,     4,     4,     1,
       2,     1,     1,     1,     1,     5,     1,     2,     1,     1,
       1,     1,     3,     3,     5,     1,     1,     1,     1,     4,
       2,     1,     3,     1,     3,     1,     4,     3,     1,     3,
       3,     1,     2,     1,     8,     2,     1,     4,     2,     1,
       3,     1,     1,     2,     4,     1,     1,     1,     1,     1,
       1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      61,     0,     0,     0,    61,     4,     3,     0,     0,     1,
       0,    61,     9,     5,    60,     0,     0,    61,    12,     0,
      61,    16,     7,     6,    59,    58,     0,     0,    13,    11,
       0,     2,    18,     8,    10,    14,     0,     0,     0,     0,
      17,    20,    19,    21,     0,    46,     0,    45,     0,    28,
       0,     0,     0,    25,    26,    27,     0,    15,    22,    23,
       0,     0,    61,    61,     0,     0,    31,     0,     0,    38,
       0,     0,    41,    51,    52,     0,    61,     0,    49,    35,
       0,    33,    29,    30,     0,    36,     0,     0,    24,    53,
      61,     0,    48,    43,     0,     0,    32,    39,    37,    40,
       0,    61,    55,    42,    61,    50,    34,     0,    56,     0,
      57,    47,     0,    44,    54
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     3,     4,     5,    11,    26,    17,    27,    34,    20,
      31,    40,    41,    42,    52,    64,    54,    65,    66,    80,
      81,    55,    68,    69,    71,    92,    43,    44,    75,    76,
      77,   101,   109,    28,    15,    78
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -34
static const yysigned_char yypact[] =
{
      -5,    -1,    13,    24,    23,    -5,   -34,     5,     5,   -34,
       5,    25,   -34,   -34,   -34,    12,    16,     9,   -34,    14,
     -34,   -34,   -34,   -34,   -34,   -34,    18,     9,   -34,   -34,
       9,    15,   -34,   -34,   -34,   -34,    19,     8,    34,     4,
     -34,   -34,   -34,   -34,    35,   -34,    22,   -34,    17,   -34,
      21,    26,    40,   -34,   -34,   -34,    27,   -34,   -34,   -34,
      45,    46,    28,    10,    47,    29,    45,    30,    33,    36,
       9,    38,   -34,    41,   -34,    32,    39,    45,   -34,    37,
      43,   -34,   -34,   -34,    53,   -34,    46,    42,   -34,   -34,
      56,    44,    48,   -34,    62,    47,   -34,   -34,   -34,   -34,
      50,    57,   -34,   -34,    10,   -34,   -34,     9,   -34,    49,
     -34,   -34,    52,   -34,   -34
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -34,   -34,   -34,    68,   -34,   -34,   -34,   -34,   -34,   -34,
     -34,   -34,   -34,   -34,   -34,   -33,   -34,    11,   -34,   -34,
     -21,   -34,   -11,   -34,   -34,   -34,   -34,   -34,   -26,   -34,
     -34,   -34,   -34,   -25,    -7,     0
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -62
static const yysigned_char yytable[] =
{
       6,    16,    35,    18,    12,    36,    53,    49,     1,     2,
      14,    21,    24,    25,     7,    50,    51,    29,   -61,    37,
      32,    58,    14,    38,     9,    39,    73,    74,     8,    10,
      22,    45,    19,    30,    23,    47,    33,    48,    56,    46,
      57,    59,    60,    62,    94,    87,    63,    61,    49,    67,
      79,    82,    90,    70,    84,    85,    88,    97,    89,    86,
      95,    96,    72,   100,    91,   105,   108,   113,    99,   107,
     103,   104,   114,    13,   106,    98,    93,    83,   111,     0,
       0,     0,   112,     0,     0,     0,     0,     0,     0,     0,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   110
};

static const yysigned_char yycheck[] =
{
       0,     8,    27,    10,     4,    30,    39,     3,    13,    14,
       5,    11,     3,     4,    15,    11,    12,    17,     3,     4,
      20,     4,     5,     8,     0,    10,    16,    17,    15,     6,
      18,    31,     7,    19,    18,    27,    18,     3,     3,    20,
      18,    48,    21,     3,    77,    70,    19,    21,     3,     3,
       3,    22,    20,    25,    24,    22,    18,     4,    17,    23,
      23,    18,    62,     7,    25,     3,     9,    18,    26,    19,
      26,    23,    20,     5,    95,    86,    76,    66,   104,    -1,
      -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    13,    14,    29,    30,    31,    63,    15,    15,     0,
       6,    32,    63,    31,     5,    62,    62,    34,    62,     7,
      37,    63,    18,    18,     3,     4,    33,    35,    61,    63,
      19,    38,    63,    18,    36,    61,    61,     4,     8,    10,
      39,    40,    41,    54,    55,    63,    20,    27,     3,     3,
      11,    12,    42,    43,    44,    49,     3,    18,     4,    62,
      21,    21,     3,    19,    43,    45,    46,     3,    50,    51,
      25,    52,    63,    16,    17,    56,    57,    58,    63,     3,
      47,    48,    22,    45,    24,    22,    23,    61,    18,    17,
      20,    25,    53,    63,    43,    23,    18,     4,    50,    26,
       7,    59,    63,    26,    23,     3,    48,    19,     9,    60,
      63,    56,    61,    18,    20
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 235 "rp2gen_parser.y"
    {
					    extern char *server_prefix;
					    server_prefix = copy(yyvsp[-1].u_string+1);
					    server_prefix[strlen(server_prefix)-1] = '\0';
					}
    break;

  case 7:
#line 241 "rp2gen_parser.y"
    {
					    extern char *client_prefix;
					    client_prefix = copy(yyvsp[-1].u_string+1);
					    client_prefix[strlen(client_prefix)-1] = '\0';
					}
    break;

  case 8:
#line 249 "rp2gen_parser.y"
    {
					    subsystem.subsystem_name = copy(yyvsp[-2].u_string+1);
					    subsystem.subsystem_name[strlen(subsystem.subsystem_name)-1] = '\0';
					}
    break;

  case 9:
#line 254 "rp2gen_parser.y"
    {
			    printf("NO SUBSYSTEM SPECIFIED: only generating header file\n");
			    HeaderOnlyFlag = 1;
			    }
    break;

  case 10:
#line 261 "rp2gen_parser.y"
    {}
    break;

  case 12:
#line 266 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;

  case 13:
#line 270 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;

  case 14:
#line 274 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;

  case 15:
#line 278 "rp2gen_parser.y"
    { subsystem.timeout = yyvsp[-2].u_string; }
    break;

  case 16:
#line 280 "rp2gen_parser.y"
    { subsystem.timeout = NIL; }
    break;

  case 21:
#line 290 "rp2gen_parser.y"
    {}
    break;

  case 22:
#line 294 "rp2gen_parser.y"
    { if (yyvsp[-2].u_bool) spit_define(yyvsp[-1].u_string, yyvsp[0].u_string); }
    break;

  case 23:
#line 296 "rp2gen_parser.y"
    { if (yyvsp[-2].u_bool) spit_define(yyvsp[-1].u_string, yyvsp[0].u_string); }
    break;

  case 24:
#line 300 "rp2gen_parser.y"
    {
					    extern void spit_type();
					    yyvsp[-3].u_entry -> name = yyvsp[-2].u_string;
					    yyvsp[-3].u_entry -> bound = yyvsp[-1].u_string;
					    if (yyvsp[-3].u_entry->bound != NIL && yyvsp[-3].u_entry->type->tag != RPC2_BYTE_TAG) {
						printf("RP2GEN: array type unimplemented: %s\n",
						       yyvsp[-2].u_string);
						exit(1);
					    }
					    enter(yyvsp[-3].u_entry);
					    if (yyvsp[-4].u_bool) spit_type(yyvsp[-3].u_entry);
					}
    break;

  case 25:
#line 315 "rp2gen_parser.y"
    { yyval.u_entry = make_entry(yyvsp[0].u_entry->type, yyvsp[0].u_entry); }
    break;

  case 26:
#line 317 "rp2gen_parser.y"
    { yyval.u_entry = make_entry(yyvsp[0].u_rpc2_type, NIL); }
    break;

  case 27:
#line 319 "rp2gen_parser.y"
    { yyval.u_entry = make_entry(yyvsp[0].u_rpc2_type, NIL); }
    break;

  case 28:
#line 323 "rp2gen_parser.y"
    {
					    yyval.u_entry = find(yyvsp[0].u_string);
					    if (yyval.u_entry == NIL) {
						printf("RP2GEN: can't find type: %s\n", yyvsp[0].u_string);
						exit(1);
					    }
					}
    break;

  case 29:
#line 333 "rp2gen_parser.y"
    { yyval.u_rpc2_type = rpc2_struct_type(make_var_array()); }
    break;

  case 30:
#line 337 "rp2gen_parser.y"
    {
					    if (var_list.counter >= MAX_VARS) {
						printf("RP2GEN: too many fields: %d\n", MAX_VARS);
						exit(1);
					    }
					    var_list.vars[var_list.counter++] = yyvsp[-1].u_var_array;
					}
    break;

  case 31:
#line 345 "rp2gen_parser.y"
    {
					    var_list.vars[0] = yyvsp[0].u_var_array;
					    var_list.counter = 1;
					}
    break;

  case 32:
#line 352 "rp2gen_parser.y"
    {
					    register char **id;
					    register VAR **p;
					    yyval.u_var_array = (VAR **) calloc(length(yyvsp[-1].u_string_array)+1, sizeof(VAR *));
					    if (yyval.u_var_array == NIL) no_storage("field");
					    for (id=yyvsp[-1].u_string_array, p=yyval.u_var_array; *id!=NIL; id++, p++)
						*p = make_var(*id, NO_MODE, yyvsp[-2].u_entry);
					    *p = NIL;
					    free(yyvsp[-1].u_string_array);
					}
    break;

  case 33:
#line 365 "rp2gen_parser.y"
    { yyval.u_string_array = make_id_array(); }
    break;

  case 34:
#line 369 "rp2gen_parser.y"
    {
					    if (id_list.counter >= MAX_IDS) {
						printf("RP2GEN: too many identifiers in list: %d\n", MAX_IDS);
						exit(1);
					    }
					    id_list.ids[id_list.counter++] = yyvsp[-2].u_string;
					}
    break;

  case 35:
#line 377 "rp2gen_parser.y"
    {
					    id_list.ids[0] = yyvsp[0].u_string;
					    id_list.counter = 1;
					}
    break;

  case 36:
#line 384 "rp2gen_parser.y"
    { yyval.u_rpc2_type = rpc2_enum_type(make_enum_array()); }
    break;

  case 37:
#line 388 "rp2gen_parser.y"
    {
					    if (enum_list.counter >= MAX_ENUMS) {
						printf("RP2GEN: too many enum values: %d\n", MAX_ENUMS);
						exit(1);
					    }
					    enum_list.enums[enum_list.counter++] = yyvsp[-2].u_enum;
					}
    break;

  case 38:
#line 396 "rp2gen_parser.y"
    {
					    enum_list.enums[0] = yyvsp[0].u_enum;
					    enum_list.counter = 1;
					}
    break;

  case 39:
#line 403 "rp2gen_parser.y"
    { yyval.u_enum = make_enum(yyvsp[-2].u_string, yyvsp[0].u_string); }
    break;

  case 40:
#line 407 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[-1].u_string; }
    break;

  case 41:
#line 409 "rp2gen_parser.y"
    { yyval.u_string = NIL; }
    break;

  case 42:
#line 413 "rp2gen_parser.y"
    {
					    yyval.u_var = make_var(NIL, NO_MODE, find("RPC2_Integer"));
					}
    break;

  case 43:
#line 417 "rp2gen_parser.y"
    { yyval.u_var = NIL; }
    break;

  case 44:
#line 421 "rp2gen_parser.y"
    { if (yyvsp[-1].u_bool == RP2_FALSE) {
                                            if (yyvsp[-7].u_int == -1)
                                                yyvsp[-7].u_int = next_opnum;
                                            if (yyvsp[-7].u_int < next_opnum) {
                                              printf("RP2GEN: Opcode numbers must be always increasing\n");
                                              exit(1);
                                            }
                                            next_opnum = yyvsp[-7].u_int + 1;
                                          }
					  insert(check_proc(make_proc(yyvsp[-7].u_int, yyvsp[-6].u_string, make_formal_array(), yyvsp[-2].u_string, yyvsp[-1].u_bool))); }
    break;

  case 45:
#line 434 "rp2gen_parser.y"
    { yyval.u_int = atoi(yyvsp[-1].u_string); }
    break;

  case 46:
#line 437 "rp2gen_parser.y"
    { yyval.u_int = -1; }
    break;

  case 47:
#line 442 "rp2gen_parser.y"
    {
					    register VAR *maxvarp;
					    if (formal_list.counter >= MAX_FORMALS) {
						printf("RP2GEN: too many formals: %d\n", MAX_FORMALS);
						exit(1);
					    }
					    formal_list.formals[formal_list.counter++] = yyvsp[-3].u_var;
					    if (yyvsp[-2].u_var != NIL) {
						if (formal_list.counter >= MAX_FORMALS) {
						    printf("RP2GEN: too many formals: %d\n", MAX_FORMALS);
						    exit(1);
						}
					        if (yyvsp[-3].u_var->type->type->tag != RPC2_STRUCT_TAG) {
						    printf("RP2GEN: array type unimplemented: %s\n", yyvsp[-3].u_var->name);
						    exit(1);
					        } 
					        formal_list.formals[formal_list.counter++] = yyvsp[-2].u_var;
						yyvsp[-3].u_var->array = yyvsp[-2].u_var->name = createsize(yyvsp[-3].u_var->name);
						yyvsp[-2].u_var->mode = yyvsp[-3].u_var->mode;
						if (yyvsp[-3].u_var->mode != IN_MODE) { 
						    maxvarp = make_var(NIL, NO_MODE, find("RPC2_Integer"));
						    yyvsp[-3].u_var->arraymax = maxvarp->name = createmaxsize(yyvsp[-3].u_var->name);
						    maxvarp->mode = IN_MODE;
						    formal_list.formals[formal_list.counter++] = maxvarp;
						}
					    }
					}
    break;

  case 48:
#line 470 "rp2gen_parser.y"
    {
					    register VAR *maxvarp;
					    formal_list.formals[0] = yyvsp[-1].u_var;
					    formal_list.counter = 1;
					    if (yyvsp[0].u_var != NIL) {
					        if (yyvsp[-1].u_var->type->type->tag != RPC2_STRUCT_TAG) {
						    printf("RP2GEN: array type unimplemented: %s\n",
						           yyvsp[-1].u_var /* Is this a char *?*/);
						    exit(1);
					        } 
					        formal_list.formals[formal_list.counter++] = yyvsp[0].u_var;
						yyvsp[-1].u_var->array = yyvsp[0].u_var->name = createsize(yyvsp[-1].u_var->name);
						yyvsp[0].u_var->mode = yyvsp[-1].u_var->mode;
						if (yyvsp[-1].u_var->mode != IN_MODE) { 
						    maxvarp = make_var(NIL, NO_MODE, find("RPC2_Integer"));
						    yyvsp[-1].u_var->arraymax = maxvarp->name = createmaxsize(yyvsp[-1].u_var->name);
						    maxvarp->mode = IN_MODE;
						    formal_list.formals[formal_list.counter++] = maxvarp;
						}
					    }

					}
    break;

  case 49:
#line 493 "rp2gen_parser.y"
    { formal_list.counter = 0; }
    break;

  case 50:
#line 497 "rp2gen_parser.y"
    {
					  yyval.u_var = make_var(yyvsp[0].u_string, yyvsp[-2].u_mode, yyvsp[-1].u_entry);
					}
    break;

  case 51:
#line 503 "rp2gen_parser.y"
    { yyval.u_mode = IN_MODE; }
    break;

  case 52:
#line 505 "rp2gen_parser.y"
    { yyval.u_mode = OUT_MODE; }
    break;

  case 53:
#line 507 "rp2gen_parser.y"
    { yyval.u_mode = IN_OUT_MODE; }
    break;

  case 54:
#line 511 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[-1].u_string; }
    break;

  case 55:
#line 513 "rp2gen_parser.y"
    { yyval.u_string = NIL; }
    break;

  case 56:
#line 517 "rp2gen_parser.y"
    { yyval.u_bool = RP2_TRUE; }
    break;

  case 57:
#line 519 "rp2gen_parser.y"
    { yyval.u_bool = RP2_FALSE; }
    break;

  case 58:
#line 523 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;

  case 59:
#line 525 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;

  case 60:
#line 529 "rp2gen_parser.y"
    { yyval.u_string = yyvsp[0].u_string; }
    break;


    }

/* Line 999 of yacc.c.  */
#line 1662 "rp2gen_parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 538 "rp2gen_parser.y"


